var lesson_filter = {"lesson_filter":3}; // 中、日标题显示设置参数【全局】
var init_Index = 0; // 上次使用最后打开的句子【当前页】
var learnEnd = {}; //已学句子标红设置【当前页】
var pageObj = {}; //记录pageID项目下设置的对象
var learnNum = 0; //已经学习的句子数目
var senlen = $('.sentence').length; //总句子数目
var maxIndex = senlen-1; //句子index的最大值
var lastIndex = -1, curIndex = -1; //记录上次打开和当前打开的句子
var isChangeCurSen = 0; //标记是否在当前句子中切换了声音链接(0为课程声，1为录音声，2为对话声)
var islisDialoSound = 0, curDialoBtn; //是否正在听对话发音 || 当前点击的发音对话按钮
var loaded = 0; //标记声音是否载入成功
var isRecord = 0, isListening = 0; //正在录音/正在听录音
var isPlayingAll = 0; //是否正在播放全部例句声音
var delaytime; //两倍时间自动停止录音的延时标记
var swiperMain,scrollContainer = []; //swiper对象
var wordOrDefine = 1; //只播放单词声音(1) 或 播放单词加释义声音(2)
var playQueue = []; //音频播放队列
var allPlayTime = 1; //全部播放的循环次数
var surplusPlayTime; //全部播放的剩余播放次数
var allPlayPosition = [0,maxIndex]; //全部播放时的播放起止位置
var keepPlay = 0; //是否继续播放下一条
var isSwipering;

$(function(){
	//页面设置初始化
	function settingInit(){
		getStorage({"key":pageID, "successCallback":"onPageID"});
	}
	//框架尺寸调整方法
	function fixPageHeight(){
		var height = $(window).height() - $('#nav').height();
		$(".swiper-main").css('height', height);
		$(".scroll-container").css('height', height);
		$("#footer").css('width', $(window).width());
		var newHeight = height - $("#footer").height();
		$(".swiper-scrollbar").css('height', newHeight);
	}

	init(); //调用全局初始化函数
	function init(){
		FastClick.attach(document.body);

		//定义框架尺寸
		$(window).on('resize',fixPageHeight);
		fixPageHeight();

		//初始化滑动组件
		swiperMain = new Swiper('.swiper-main',{
			mousewheelControl : true,
			onSlideChangeStart: function(swiper){
				$('#nav span').removeClass('active');
				$('#navbtn'+swiper.activeIndex).addClass('active');
				isSwipering = 1;
				setTimeout(function(){isSwipering = 0;},50);
				clickConflictTest();
			}
		});

		$('.scroll-container').each(function(){
			var sc = $(this).swiper({
				scrollContainer: true,
				mousewheelControl : true,
			    mode:'vertical',
			    scrollbar: {
			      container: '.swiper-scrollbar'
			    }
			});
			scrollContainer.push(sc);
		});
		
		settingInit(); // 页面设置初始化

		showSenInit(); //句子弹开初始化

		//绑定nav点击事件
		$('#nav span').on('click',function(){
			swiperMain.swipeTo($(this).attr('index'));
		});

		//绑定单元练习按钮点击事件
		$('#zhongri').on('click',function(){
			openLesson({"lesson_key": pageID});
		});

		//绑定设置图标点击事件
		$('#optionBtn').on('click',function(){
			clickConflictTest();
			openPrmSettingPanel();
		});

		audioPlayInit(); //音频播放功能初始化

		audioRecordInit(); //录音与播放录音初始化

		addScbInit(); //添加生词本初始化
	}

	
	function showSenInit(){
		//为每条句子绑定click事件
		$('.sentence').on('click',function(){
			if(!isSwipering){
				clickConflictTest();
				showSentence(this);
			}
		});
	}


/** 音频播放处理模块
*	参数：
*		isPlaying  //标记是否正在播放
*		keepPlay  //标记是否需要继续播放下一条
*	方法：
*		playProgress  //音频播放进度方法
*		circleRotate  //圆形进度条转动方法
*		playAllSoundInit  //playAllSound 按钮初始化
*		keepPlaying  //继续播放下一条方法
*		audioPlayInit  //音频播放功能初始化（音频监听器）
*/
	//音频播放进度方法
	function playProgress(adu,nu){
		var perc = adu.currentTime / adu.duration;
		circleRotate(perc,nu);
		if((perc < 1) && (!adu.paused)){
			setTimeout(function(){
				playProgress(adu,nu);
			},100);
		}
	}
	//圆形进度条转动方法
	function circleRotate(perc,nu){
		var angle = 360*perc;
		var innerR = $('.sentence.active').find('.innerRight')[nu];
		var innerL = $('.sentence.active').find('.innerLeft')[nu];
		if(angle<180){
			$(innerR).css({'-webkit-transform': 'rotate('+angle+'deg)'});
		}
		else {
			$(innerR).css({'-webkit-transform': 'rotate(180deg)'});
			$(innerL).css({'-webkit-transform': 'rotate('+(angle-180)+'deg)'});
		}
	}

	//playAllSound 按钮初始化
	function playAllSoundInit(){
		var This = $('#playAllSound');
		surplusPlayTime = allPlayTime;
		if(!isPlayingAll) {
			clickConflictTest();
			$(This).addClass('playing');
			isPlayingAll = 1;
			//判断起始播放位置
			if(curIndex < allPlayPosition[0] || curIndex >= allPlayPosition[1]){
				//开始位置等于结束位置，不跳转
				if(!((allPlayPosition[0] == allPlayPosition[1]) && (curIndex == allPlayPosition[1]))){
					//跳转到起始位置
					showSentence($('.sentence')[allPlayPosition[0]]);
				}
			}
			swipeToCur();
			var sen = $('.sentence')[curIndex];
			//判断是否需要替换链接
			if(isChangeCurSen) {
				playOrPauseAudio($(sen).find('.btnGroup')[0],1);
				isChangeCurSen = 0;
			}
			//判断当前打开句子是否在播放
			else if(listenVoice.paused){
				playOrPauseAudio($(sen).find('.btnGroup')[0]);
			}
			//判断是否需要跳过当前句子
			if($(sen).find('.btnGroup').attr('skipPlay')){
				keepPlaying();
			}
			keepPlay = 1;
		}
		else {
			$(This).removeClass('playing');
			isPlayingAll = 0;
			keepPlay = 0;
			listenVoice.pause();
	        isPlaySound = 0;
	        var icon = $(".sentence.active").find('.playSound')[0];
	        $(icon).removeClass('stopSound');
		}
	}
	
	//继续播放下一条方法
	function keepPlaying(){
		if(curIndex < allPlayPosition[1]){
			var id = curIndex+1;
			var sen = $('.sentence')[id];
			showSentence(sen);
			swipeToCur();
			
			if($('.sentence.active').find('.btnGroup').attr('skipPlay')){
				keepPlaying();
			}
		}
		else if(curIndex == allPlayPosition[1]) {
			if(--surplusPlayTime == 0){
				loaded = 0;
				listenVoice.load();
				playAllSoundInit();
			}
			else {
				if(allPlayPosition[0] != allPlayPosition[1]){
					showSentence($('.sentence')[allPlayPosition[0]]);
					swipeToCur();
				}
				else {
					//继续播放当前词条
					listenVoice.autoplay = 1;
					if(wordOrDefine == 1){
						loaded = 0;
						listenVoice.load();
					}
					else if(wordOrDefine == 2){
			        	playQueue.push(wordAudioPath[curIndex],pahAudioPath[curIndex]);
			        	listenVoice.src = audioPrefix + playQueue.shift();
			        	loaded = 0;
						listenVoice.load();
			        }
				}
				if($('.sentence.active').find('.btnGroup').attr('skipPlay')){
					keepPlaying();
				}
			}
		}
	}

	//音频播放功能初始化
	function audioPlayInit(){
		//为播放按钮增加侦听器事件
		$('.playSound').on('click',function(e){
			e.stopPropagation();
			var skipPause = 0;
			if (!isPlaySound) {
				clickConflictTest();
			}
			else {
				if(isPlayingAll){
					isPlayingAllTest();
					skipPause = 1;
				}
			}
			if(isChangeCurSen) {
				playOrPauseAudio($(this).parent(),1);
				isChangeCurSen = 0;
			}
			else {
				if(!skipPause){
					playOrPauseAudio($(this).parent());
				}
			}
		});
		$('#listenVoice').on('canplay',function(){
			loaded = 1;
			if(this.autoplay){
				this.autoplay = 0;
				if(isChangeCurSen == 1){
					isListening = 1;
					islisDialoSound = 0;
					isPlaySound = 0;
		            this.play();
				}
				else if(isChangeCurSen == 2){
					islisDialoSound = 1;
					isListening = 0;
					isPlaySound = 0;
		            this.play();
				}
				else {
					var icon = $('.sentence.active').find('.playSound')[0];
		        	$(icon).addClass('stopSound');
		            isPlaySound = 1;
		            isListening = 0;
		            islisDialoSound = 0;
		            this.play();
		            delaytime = listenVoice.duration * 2000;
		            if(delaytime > 100000){
			            setTimeout(function(){
				            delaytime = listenVoice.duration * 2000;
			            },100);
			        }
				}
			}
			else {
				if(!isChangeCurSen){
					delaytime = listenVoice.duration * 2000;
					if(delaytime > 100000){
						listenVoice.currentTime = 0.01;
			            setTimeout(function(){
				            delaytime = listenVoice.duration * 2000;
			            },200);
			        }
			    }
			}
		});
		$('#listenVoice').on('playing',function(){
			if(isListening){
				var btn = $('.sentence.active').find('.listenSound')[0];
				$(btn).addClass('lis');
				preparePlayProgress(1);
				playProgress(this,1);
			}
			else if(islisDialoSound){
				dialoSoundAnimateStart();
			}
			else {
				preparePlayProgress(0);
				playProgress(this,0);
			}
		});
		$('#listenVoice').on('pause',function(){
			if(isListening){
				isListening = 0;
				var btn = $('.sentence.active').find('.listenSound')[0];
	            $(btn).removeClass('lis');
	            endPlayProgress(1);
	        }
	        else if(islisDialoSound){
				dialoSoundAnimateStop();
				islisDialoSound = 0;
			}
	        else {
	        	endPlayProgress(0);
	        }
		});
		$('#listenVoice').on('ended',function(){
			if(isListening){
				var btn = $('.sentence.active').find('.listenSound')[0];
				$(btn).removeClass('lis');
				isListening = 0;
				var cir = $('.sentence.active').find('.circleBorder')[1];
				$(cir).removeClass("show");
			}
			else if(islisDialoSound){
				dialoSoundAnimateStop();
				islisDialoSound = 0;
			}
			else {
				var cir = $('.sentence.active').find('.circleBorder')[0];
				$(cir).removeClass("show");
				var icon = $('.sentence.active').find('.playSound')[0];
				$(icon).removeClass('stopSound');
				var nextAudio = playQueue.shift();
				if(nextAudio){
					this.src = audioPrefix + nextAudio;
					loaded = 0;
					this.load();
					this.autoplay = 1;
				}
				else {
					if(keepPlay){
						setTimeout(keepPlaying, 500);
					}
					else {
						if(wordOrDefine == 1){
							if(!isIOS){
								loaded = 0;
								this.load();
							}
						}
						else if(wordOrDefine == 2){
				        	playQueue.push(wordAudioPath[curIndex],pahAudioPath[curIndex]);
				        	this.src = audioPrefix + playQueue.shift();
				        	loaded = 0;
							this.load();
				        }
					}
				}
				isPlaySound = 0;
			}
		});
		$('#listenVoice').on('stalled',function(){
			if(!loaded){
				loaded = 0;
				this.autoplay = 1;
				this.load();
			}
		});
		$('#listenVoice').on('error',function(e){
			if((!isChangeCurSen)&&(this.error.code == 4)&&(this.getAttribute('src'))){
				var btnG = $('.sentence.active').find('.btnGroup')[0];
				$(btnG).addClass('error');
				$(btnG).attr('skipPlay', 1);
			}
		});
		$('#playAllSound').click(playAllSoundInit);
	}

/** 录音与播放录音模块
*	参数：
*		recordPlayAni  //录音动画标记
*	方法：
*		recordPlayAudioAnimate  //录音播放动画方法入口
*		recordPlayAudioIconAnimate  //录音播放动画切换图标方法
*		stoprecordPlayAudioAnimate  //移除录音播放动画
*		audioRecordInit  //录音与播放录音初始化
*/
	
	//录音与播放录音初始化
	function audioRecordInit(){
		$('.recordSound').on('click',function(e){
			e.stopPropagation();
			if(!isRecord){
				clickConflictTest();
			}
			var uwid = $(this).attr('id');
			var json = {'uwid': uwid};
			if(!this.state){
				this.state = 1;
				if(!isRecord){
					startRecord(json);
				}
				else {
					json.invaild = 1;
					stopRecord(json);
					clearTimeout(autoStopRecord);
				}
			}
		});
		//为录音播放按钮添加监听事件
		$('.listenSound').on('click',function(e){
	        e.stopPropagation();
	        if(!isListening){
	        	clickConflictTest();
	        	var index = $(this).parent().attr('index')-1;
	        	isChangeCurSen = 1;
	        	playQueue = [];
		        listenVoice.src = recordAudioPath[index];
		        loaded = 0;
		        listenVoice.autoplay = 1;
		        listenVoice.load();
	        }
	        else {
	            listenVoice.pause();
	        }
	    });
	}


/** 添加生词本模块
*	方法：
*		addScbInit  //添加生词本按钮初始化
*/
	//添加生词本按钮初始化
	function addScbInit(){
		$('.addStar').on('click',function(e){
			e.stopPropagation();
			clickConflictTest();
			var uwid = $(this).parent().find('.recordSound').attr('id');
			var json = {'uwid': uwid};
			addScb(json);
		});
	}




});



//定义中、日或是中+日
//id值可能是：1（中）、2（日）、3（中+日）
function senTitleWordChange(id) {
    if(id){
        if (id==1) {
            $('.senTitleWord').each(function(){
                $(this).removeClass('only-ri');
                $(this).addClass('only-zhong');
            });
        }
        else if(id==2){
            $('.senTitleWord').each(function(){
                $(this).removeClass('only-zhong');
                $(this).addClass('only-ri');
            });
        }
        else if (id==3) {
            $('.senTitleWord').each(function(){
                $(this).removeClass('only-zhong');
                $(this).removeClass('only-ri');
            });
        }

        $('.sentence.active').find('.senTitleWord').each(function(){
            $(this).removeClass('only-ri only-zhong');
        });
    }
}
//中、日显示初始化
function senTitleWordInit(lastFilter){
    //根据上次保存设置初始化
    if(lastFilter != lesson_filter.lesson_filter) {
        senTitleWordChange(lesson_filter.lesson_filter);
        if(lesson_filter.lesson_filter == 1){
            scrollContainer[0].resizeFix(1);
            swipeToCur();
			$('.senNum').removeClass('zhongri');
        }
        else if(lesson_filter.lesson_filter == 3){
            scrollContainer[0].resizeFix(1);
            swipeToCur();
            $('.senNum').addClass('zhongri');
        }
    }
}

//html文本互换
function swapHtmlText(senTW){
	var htmlText = $(senTW).find('.zhong').html();
    $(senTW).find('.zhong').html($(senTW).find('.ri').html());
    $(senTW).find('.ri').html(htmlText);
}

//句子弹开与关闭
function showSentence(sen,first) {
    lastIndex = curIndex;
    curIndex = $(sen).index();
    //判断两次点击是否是同一条句子，分情况处理
    if(curIndex == lastIndex){
        $(sen).removeClass('active');
        $(sen).find('.xieyin').addClass('hide');
        stopAudio();
        curIndex = -1;
    }
    else {
        if (lastIndex >= 0) {
            var oldSen = $('.sentence')[lastIndex];
            $(oldSen).removeClass('active');
            $(oldSen).find('.xieyin').addClass('hide');
            stopAudio();
        }
        $(sen).addClass('active');
        //判断录音数据是否已存在、生词本是否已添加
		var json = {"uwid": $(sen).attr('name')};
		refreshRecordPath(json);
		refreshFavorite(json);
        $(sen).find('.xieyin').removeClass('hide');
        if(first){
            $(sen).find('.progressIcon').hide();
            if(wordOrDefine == 1){
            	playQueue.push(wordAudioPath[curIndex]);
	        }
	        else if(wordOrDefine == 2){
	        	playQueue.push(wordAudioPath[curIndex],pahAudioPath[curIndex]);
	        }
	        listenVoice.src = audioPrefix + playQueue.shift();
		    loaded = 0;
            listenVoice.load();
        }
        else {
            playOrPauseAudio($(sen).find('.btnGroup')[0],1);
        }
    }
    scrollContainer[0].resizeFix(1);
    //处理已学习记录的样式变化
    if(curIndex >= 0 && !(learnEnd[curIndex])){
        $(sen).find('.senTitle').addClass('redcolor');
        learnEnd[curIndex] = 1;
        learnNum++;
        $('#progress').css({'-webkit-transform': 'scaleX('+learnNum/senlen+')'});
        if(learnNum == senlen){
            $('#progress').addClass('full');
        }
    }
    init_Index = curIndex;
    pageObj.init_Index = init_Index;
    pageObj.learnEnd = learnEnd;
    setStorage({"key":pageID, "value":pageObj});

    if(lesson_filter.lesson_filter == 2){
        activeRi(sen,"only-ri");
    }
    else if(lesson_filter.lesson_filter == 1){
    	activeRi(sen,"only-zhong");
    }

    //反馈当前打开词条信息给客户端
    var json = {};
    json.id = pageID;
    json.uwid = $(sen).attr('name');
    refreshStudyStatus(json);
    
}
//处理只显示日文情况下，active变化的问题
function activeRi(sen,className){
    if(curIndex >= 0) {
        var senTW = $(sen).find('.senTitleWord')[0];
        $(senTW).removeClass(className);
        if(className == "only-ri"){
        	swapHtmlText(senTW);
        }
        if(lastIndex >= 0) {
            var oldSen = $('.sentence')[lastIndex];
            var senTW = $(oldSen).find('.senTitleWord')[0];
	        $(senTW).addClass(className);
	        if(className == "only-ri"){
	        	swapHtmlText(senTW);
	        }
        }
    }
    else {
        var senTW = $(sen).find('.senTitleWord')[0];
        $(senTW).addClass(className);
        if(className == "only-ri"){
        	swapHtmlText(senTW);
        }
    }
}

/** 音频播放处理模块
*   参数：
*       isPlaySound (标记音频是否正在播放)
*   方法：
*       playOrPauseAudio（播放或暂停）
*       stopAudio （停止播放）
*/
//播放或暂停音频音频
var isPlaySound = 0; //是否正在播放声音
function playOrPauseAudio(btng,changeSen){
    var icon = $(btng).find('.playSound')[0];
    if(changeSen){
        //加载音频资源
        var index = $(btng).attr('index')-1;
		isChangeCurSen = 0;
        loaded = 0;
        listenVoice.autoplay = 1;
        playQueue = [];
        if(wordOrDefine == 1){
        	playQueue.push(wordAudioPath[curIndex]);
        }
        else if(wordOrDefine == 2){
        	playQueue.push(wordAudioPath[curIndex],pahAudioPath[curIndex]);
        }
        listenVoice.src = audioPrefix + playQueue.shift();
        listenVoice.load();
    }
    else {
        if (listenVoice.paused) {
            listenVoice.play();
            $(icon).addClass('stopSound');
            isPlaySound = 1;
            return;
        }
        listenVoice.pause();
        isPlaySound = 0;
        $(icon).removeClass('stopSound');
    }
}
function stopAudio(){
    listenVoice.src = "";
    isPlaySound = 0;
}

//跳转到当前打开句子方法
function swipeToCur(){
    var dis = 0;
    for(var i = 0; i < curIndex; i++){
        dis += $($('.sentence')[i]).height();
    }
    scrollContainer[0].setWrapperTranslate(0, -dis,0);
}

/** 录音功能模块
*   参数：
*       recordani  （标记录音动画）
*       recordAudioPath  (记录录音文件路径)
*   方法：
*       recordAudioAnimate  （开始录音后的动画）
*       recordAudioIconAnimate （录音动画循环体）
*       stopRecordEvent  （停止录音后清除动画，调用更新录音文件方法）
*       refreshListenSoundBtn （更新录音文件方法）
*/
var recordAudioPath = {};
var autoStopRecord; //自动两倍延时关闭录音
//录音动画方法
var recordani;
function recordAudioAnimate(uwid){
    var btn = $("#"+uwid)[0];
    btn.state = 0; //标记按钮接收点击事件
    $(btn).addClass('work');
    var curr = 0;
    recordani = setInterval(function(){
        curr = (curr+1) % 5;
        recordAudioIconAnimate(curr,btn);
    }, 200);
}
function recordAudioIconAnimate(curr,icon){
    var last = curr-1;
    if(last<0){
        last = 4;
    }
    $(icon).removeClass('ani'+last);
    if(curr>0){
        $(icon).addClass('ani'+curr);
    }
}
//停止录音方法
function stopRecordEvent(uwid,filePath){
    //清除录音按钮动画
    clearInterval(recordani);
    var btn = $("#"+uwid)[0];
    btn.state = 0; //标记按钮接收点击事件
    $(btn).removeClass('work');
    for(var i=1; i<5; i++){
        $(btn).removeClass('ani'+i);
    }
    if(filePath){
        refreshListenSoundBtn(uwid, filePath);
    }
}
//更新播放录音状态
function refreshListenSoundBtn(uwid, filePath){
    var btn = $("#"+uwid);
    //显示播放录音按钮，并为 recordVoice 声音标签设置声音链接
    var listenBtn = $(btn).parent().find('.listenSound');
    var index = $(btn).parent().attr('index')-1;
    $(listenBtn).removeClass('hide');
    recordAudioPath[index] = filePath;
}

//播放对话按钮动画
function dialoSoundAnimateStart(){
	var btn = $(curDialoBtn)[0];
	btn.state = 0;
	btn.ani = 1;
	dialoSoundAni(btn);
}
function dialoSoundAni(btn){
	$(btn).removeClass('state'+btn.state);
	btn.state = ++btn.state>2 ? 0 : btn.state;
	$(btn).addClass('state'+btn.state);
	setTimeout(function(){
		if(btn.ani){
			dialoSoundAni(btn);
		}
	},300);
}
function dialoSoundAnimateStop(){
	var btn = $(curDialoBtn)[0];
	btn.ani = 0;
	$(btn).removeClass('state1 state2').addClass('state0');
}

//播放进度动画准备
function preparePlayProgress(nu){
	var cir = $('.sentence.active').find('.circleBorder')[nu];
	$(cir).addClass("show");
	var pro = $('.sentence.active').find('.progressIcon')[nu];
	$(pro).show();
	var inL = $('.sentence.active').find('.innerLeft')[nu];
	$(inL).css({'-webkit-transform': 'rotate(0deg)'});
}
//播放进度动画收尾
function endPlayProgress(nu){
	var cir = $('.sentence.active').find('.circleBorder')[nu];
	$(cir).removeClass("show");
	var pro = $('.sentence.active').find('.progressIcon')[nu];
	$(pro).hide();
	var inR = $('.sentence.active').find('.innerRight')[nu];
	var inL = $('.sentence.active').find('.innerLeft')[nu];
	$(inR).css({'-webkit-transform': 'rotate(0deg)'});
	$(inL).css({'-webkit-transform': 'rotate(0deg)'});
}

//获取当前页面ID对应参数后初始化
function pageIDInit(json){
	if(!json.value){
        for(var i = 0; i < senlen; i++){
            learnEnd[i] = 0;
        }
        pageObj.learnEnd = learnEnd;
        pageObj.init_Index = init_Index;
        pageObj.lesson_filter = lesson_filter;
        pageObj.allPlaySetting = {"allPlayPosition": allPlayPosition, "wordOrDefine": wordOrDefine, "allPlayTime": allPlayTime};
        setStorage({"key":pageID, "value":pageObj});
    }
    else {
        var pageSet = parseJson(json.value);
        init_Index = pageSet.init_Index;
        learnEnd = pageSet.learnEnd;
        lesson_filter = pageSet.lesson_filter;
        var allPlaySetting = parseJson(pageSet.allPlaySetting);
        allPlayPosition = allPlaySetting.allPlayPosition;
        wordOrDefine = allPlaySetting.wordOrDefine;
        allPlayTime = allPlaySetting.allPlayTime;
        //初始化pageObj的所有字段
        pageObj.learnEnd = learnEnd;
        pageObj.init_Index = init_Index;
        pageObj.lesson_filter = lesson_filter;
        pageObj.allPlaySetting = allPlaySetting;
    }
    senTitleWordInit(0); //中、日显示初始化
    for(var j in learnEnd){
        if(learnEnd[j] == 1){
            $($('.sentence')[j]).find('.senTitle').addClass('redcolor');
            learnNum++;
        }
    }
    $('#progress').css({'-webkit-transform': 'scaleX('+learnNum/senlen+')'});
    if(learnNum == senlen){
        $('#progress').addClass('full');
    }
    //根据auto_uwid跳转
    if(auto_uwid && (auto_uwid != "0")) {
        showSentence($('#'+auto_uwid).parent().parent().parent(), 1);
        swipeToCur();
    }
    //根据用户上次打开的句子跳转
    else if (init_Index >= 0) {
        showSentence($('.sentence')[init_Index], 1);
        swipeToCur();
    }
}

//弹出native设置面板后更新参数设置方法
function refreshPrmSetting(jsonData){
	if(jsonData.allPlayPosition){
        //用户保存设置
        var arr = jsonData.allPlayPosition;
        allPlayPosition = [];
        for(var i = 0; i < arr.length; i++){
        	allPlayPosition.push(arr[i]-1);
        }
        if(wordOrDefine != jsonData.wordOrDefine){
        	wordOrDefine = jsonData.wordOrDefine;
        	loaded = 0;
	        playQueue = [];
	        if(wordOrDefine == 1){
	        	playQueue.push(wordAudioPath[curIndex]);
	        }
	        else if(wordOrDefine == 2){
	        	playQueue.push(wordAudioPath[curIndex],pahAudioPath[curIndex]);
	        }
	        listenVoice.src = audioPrefix + playQueue.shift();
	        listenVoice.load();
        }
        allPlayTime = parseInt(jsonData.allPlayTime);
        var lastFilter = lesson_filter.lesson_filter;
        lesson_filter = jsonData.lesson_filter;
        senTitleWordInit(lastFilter); //中、日显示切换
        //保存新设置进localstorage
        pageObj.allPlaySetting = {"allPlayPosition": allPlayPosition, "wordOrDefine": wordOrDefine, "allPlayTime": allPlayTime};
        pageObj.lesson_filter = lesson_filter;
        setStorage({"key":pageID, "value":pageObj});
    }
    else {
        //用户放弃设置
    }
}

/** 冲突检测模块
*	方法：
*		clickConflictTest  //点击事件冲突检测方法
*/
//点击事件冲突检测方法
function clickConflictTest(){
	if(isPlaySound){
		listenVoice.pause();
		var icon = $('.sentence.active').find('.playSound')[0];
        $(icon).removeClass('stopSound');
        endPlayProgress(0);
        isPlaySound = 0;
	}
	if(isRecord){
		var uwid = $('.sentence.active').attr('name');
		var json = {'uwid': uwid};
		json.invaild = 0;
		stopRecord(json);
		clearTimeout(autoStopRecord);
		isRecord = 0;
	}
	if(isListening){
		listenVoice.pause();
		var btn = $('.sentence.active').find('.listenSound')[0];
		$(btn).removeClass('lis');
		endPlayProgress(1);
        isListening = 0;
	}
	if(islisDialoSound){
		listenVoice.pause();
		islisDialoSound = 0;
		dialoSoundAnimateStop();		
	}
	isPlayingAllTest();
}
//isPlayingAll冲突检测
function isPlayingAllTest(){
	if(isPlayingAll){
		$('#playAllSound').removeClass('playing');
		isPlayingAll = 0;
		keepPlay = 0;
		listenVoice.pause();
        isPlaySound = 0;
        var icon = $(".sentence.active").find('.playSound')[0];
        $(icon).removeClass('stopSound');
	}
}